
;CodeVisionAVR C Compiler V2.04.6 Evaluation
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _seconds=R5
	.DEF _minutes=R4
	.DEF _hours=R7

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_ledHours:
	.DB  0x32,0x51,0x67,0x69,0x6B,0x59,0x3B,0x1D
	.DB  0x7,0x5,0x3,0x15
_decimals:
	.DB  0x1F,0x11,0x1F,0x4,0x2,0x1F,0x1D,0x15
	.DB  0x17,0x15,0x15,0x1F,0x7,0x4,0x1F,0x17
	.DB  0x15,0x1D,0x1F,0x15,0x1D,0x1,0x1,0x1F
	.DB  0x1F,0x15,0x1F,0x17,0x15,0x1F
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0002

_0x91:
	.DB  0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  0x04
	.DW  _0x91*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Compiler            : CodeVisionAVR 2.04.6 Evaluation
;Chip type           : ATmega8
;Clock frequency     : 8 MHz (int. RC-OSC)
;*****************************************************/
;
;//***************************************************
;// Bing Bong - eine Uhr mit Big Ben Melodie
;// auf Basis des Franzis-Pingpong
;// http://www.elo-web.de/ping-pong-start
;//***************************************************
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <delay.h>
;#include <sleep.h>
;
;
;#define P_CLK    PORTB.3
;#define P_DATA   PORTB.4
;#define P_STROBE PORTB.2
;
;#define PIN_COIN     PIND.2
;#define PULLUP_COIN  PORTD.2
;#define DIR_COIN     DDRD.2
;#define COIN_INSERTED (PIN_COIN == 0)
;
;#define PIN_KEY     PIND.3
;#define PULLUP_KEY  PORTD.3
;#define KEY_PRESSED (PIN_KEY == 0)
;
;#define P_SHUTDOWN_SD    PORTD.1    // Portpin for /Shutdown of SD card player
;#define DP_SHUTDOWN_SD   DDRD.1
;#define SD_PLAYER_OFF  (P_SHUTDOWN_SD = 0)
;#define SD_PLAYER_ON   (P_SHUTDOWN_SD = 1)
;
;#define P_SDA     PORTC.4    // Portpin for SDA
;#define DP_SDA    DDRC.4
;#define PIN_SDA   PINC.4
;
;#define P_SCL     PORTC.5    // Portpin for SCL
;#define DP_SCL    DDRC.5
;#define PIN_SCL   PINC.5
;
;
;#define WIDTH  12  // number of fields in horizontal direction
;#define HEIGHT 10  // number of fields in vertical direction
;
;unsigned char ledState[WIDTH*HEIGHT];  // current state of each LED
;
;enum { LED_OFF = 0, LED_ON, LED_DIM }; // possible states of a LED
;#define BLINKING 0x80                  // to set a LED blinking, it is ORed with 0x80
;
;unsigned char seconds = 0;             // current time: seconds
;unsigned char minutes = 0;             // current time: minutes
;unsigned char hours = 0;               // current time: hours
;bit bSound = 0;                        // 1=play sound
;
;flash unsigned char ledHours[12] =     // LED numbers for all 12 hours (0..11)
;{
;   50, 81, 103, 105, 107, 89, 59, 29, 7, 5, 3, 21
;};
;
;flash unsigned char decimals[] =
;{                   // Font for decimal values
;0x1F, 0x11, 0x1F,   // 0
;0x04, 0x02, 0x1F,   // 1
;0x1D, 0x15, 0x17,   // 2
;0x15, 0x15, 0x1F,   // 3
;0x07, 0x04, 0x1F,   // 4
;0x17, 0x15, 0x1D,   // 5
;0x1F, 0x15, 0x1D,   // 6
;0x01, 0x01, 0x1F,   // 7
;0x1F, 0x15, 0x1F,   // 8
;0x17, 0x15, 0x1F    // 9
;};
;
;
;// clear the whole screen, all LEDs off
;void clearScreen(void)
; 0000 0051 {

	.CSEG
_clearScreen:
; 0000 0052    unsigned char i;
; 0000 0053 
; 0000 0054    for(i = 0; i < (WIDTH*HEIGHT); i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,120
	BRSH _0x5
; 0000 0055    {
; 0000 0056       ledState[i] = LED_OFF;
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 0057    }
	SUBI R17,-1
	RJMP _0x4
_0x5:
; 0000 0058 }
	RJMP _0x2080006
;
;
;
;// wait until key is pressed
;void waitUntilKeypressed(void)
; 0000 005E {
_waitUntilKeypressed:
; 0000 005F    while(!KEY_PRESSED);
_0x6:
	LDI  R26,0
	SBIC 0x10,3
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x6
; 0000 0060    delay_ms(20);
	RJMP _0x2080008
; 0000 0061 }
;
;
;// wait until key is released
;void waitUntilKeyreleased(void)
; 0000 0066 {
_waitUntilKeyreleased:
; 0000 0067    while(KEY_PRESSED);
_0x9:
	SBIS 0x10,3
	RJMP _0x9
; 0000 0068    delay_ms(20);
_0x2080008:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x2
; 0000 0069 }
	RET
;
;
;// check if key is pressed
;// return: 0=key not pressed, 1=key pressed
;unsigned char keyPressed(void)
; 0000 006F {
_keyPressed:
; 0000 0070    unsigned char result = 0;
; 0000 0071 
; 0000 0072    if(KEY_PRESSED)
	ST   -Y,R17
;	result -> R17
	LDI  R17,0
	SBIS 0x10,3
; 0000 0073       result = 1;
	LDI  R17,LOW(1)
; 0000 0074    delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x2
; 0000 0075 
; 0000 0076    return result;
	RJMP _0x2080005
; 0000 0077 }
;
;
;
;// Timer 0 overflow interrupt service routine
;// multiplexing of LEDs
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 007E {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 007F    #define FRAME_MASK 0x03
; 0000 0080    static unsigned char count = 0;
; 0000 0081    static unsigned char framecount = 0;
; 0000 0082    static unsigned int blinkcounter = 0;
; 0000 0083    static bit bBlinkOn = 1;
; 0000 0084    bit bLed;
; 0000 0085    unsigned char state, i, value1, value2, value3;
; 0000 0086    unsigned char *pState;
; 0000 0087 
; 0000 0088    blinkcounter++;
	SBIW R28,2
	RCALL __SAVELOCR6
;	bLed -> R15.0
;	state -> R17
;	i -> R16
;	value1 -> R19
;	value2 -> R18
;	value3 -> R21
;	*pState -> Y+6
	LDI  R26,LOW(_blinkcounter_S0000004000)
	LDI  R27,HIGH(_blinkcounter_S0000004000)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0089    if(blinkcounter == 1000)
	LDS  R26,_blinkcounter_S0000004000
	LDS  R27,_blinkcounter_S0000004000+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRNE _0xD
; 0000 008A    {
; 0000 008B       bBlinkOn = ~bBlinkOn;
	LDI  R30,LOW(2)
	EOR  R2,R30
; 0000 008C       blinkcounter = 0;
	LDI  R30,LOW(0)
	STS  _blinkcounter_S0000004000,R30
	STS  _blinkcounter_S0000004000+1,R30
; 0000 008D    }
; 0000 008E 
; 0000 008F    count++;
_0xD:
	LDS  R30,_count_S0000004000
	SUBI R30,-LOW(1)
	STS  _count_S0000004000,R30
; 0000 0090    if(count >= 12)
	LDS  R26,_count_S0000004000
	CPI  R26,LOW(0xC)
	BRLO _0xE
; 0000 0091    {
; 0000 0092       count = 0;
	LDI  R30,LOW(0)
	STS  _count_S0000004000,R30
; 0000 0093       P_DATA = 0;
	CBI  0x18,4
; 0000 0094       framecount++;
	RCALL SUBOPT_0x3
	SUBI R30,-LOW(1)
	STS  _framecount_S0000004000,R30
; 0000 0095    }
; 0000 0096    else
	RJMP _0x11
_0xE:
; 0000 0097    {
; 0000 0098       P_DATA = 1;
	SBI  0x18,4
; 0000 0099    }
_0x11:
; 0000 009A    P_CLK = 1;
	SBI  0x18,3
; 0000 009B    P_CLK = 0;
	CBI  0x18,3
; 0000 009C 
; 0000 009D    pState = &ledState[count*HEIGHT];
	LDS  R26,_count_S0000004000
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
; 0000 009E 
; 0000 009F    value1 = 0;
	LDI  R19,LOW(0)
; 0000 00A0    for(i = 0; i < 4; i++)
	LDI  R16,LOW(0)
_0x19:
	CPI  R16,4
	BRSH _0x1A
; 0000 00A1    {
; 0000 00A2       value1 >>= 1;
	RCALL SUBOPT_0x5
	ASR  R31
	ROR  R30
	MOV  R19,R30
; 0000 00A3       state = (*pState) & (~BLINKING);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
; 0000 00A4       bLed = 0;
; 0000 00A5       if(state == LED_ON)
	BREQ _0x8D
; 0000 00A6       {
; 0000 00A7          bLed = 1;
; 0000 00A8       }
; 0000 00A9       else if(state == LED_DIM)
	CPI  R17,2
	BRNE _0x1D
; 0000 00AA       {
; 0000 00AB          if((framecount & FRAME_MASK) == FRAME_MASK)
	RCALL SUBOPT_0x8
	BRNE _0x1E
; 0000 00AC             bLed = 1;
_0x8D:
	SET
	BLD  R15,0
; 0000 00AD       }
_0x1E:
; 0000 00AE       if((*pState) & BLINKING)
_0x1D:
	RCALL SUBOPT_0x6
	ANDI R30,LOW(0x80)
	BREQ _0x1F
; 0000 00AF       {
; 0000 00B0          if(!bBlinkOn)
	SBRS R2,1
; 0000 00B1             bLed = 0;
	RCALL SUBOPT_0x9
; 0000 00B2       }
; 0000 00B3       if(bLed)
_0x1F:
	SBRC R15,0
; 0000 00B4       {
; 0000 00B5          value1 |= 0x08;
	ORI  R19,LOW(8)
; 0000 00B6       }
; 0000 00B7       pState++;
	RCALL SUBOPT_0xA
; 0000 00B8    }
	SUBI R16,-1
	RJMP _0x19
_0x1A:
; 0000 00B9 
; 0000 00BA    value2 = 0;
	LDI  R18,LOW(0)
; 0000 00BB    for(i = 0; i < 4; i++)
	LDI  R16,LOW(0)
_0x23:
	CPI  R16,4
	BRSH _0x24
; 0000 00BC    {
; 0000 00BD       value2 >>= 1;
	MOV  R30,R18
	RCALL SUBOPT_0xB
	MOV  R18,R30
; 0000 00BE       state = (*pState) & (~BLINKING);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
; 0000 00BF       bLed = 0;
; 0000 00C0       if(state == LED_ON)
	BREQ _0x8E
; 0000 00C1       {
; 0000 00C2          bLed = 1;
; 0000 00C3       }
; 0000 00C4       else if(state == LED_DIM)
	CPI  R17,2
	BRNE _0x27
; 0000 00C5       {
; 0000 00C6          if((framecount & FRAME_MASK) == FRAME_MASK)
	RCALL SUBOPT_0x8
	BRNE _0x28
; 0000 00C7             bLed = 1;
_0x8E:
	SET
	BLD  R15,0
; 0000 00C8       }
_0x28:
; 0000 00C9       if((*pState) & BLINKING)
_0x27:
	RCALL SUBOPT_0x6
	ANDI R30,LOW(0x80)
	BREQ _0x29
; 0000 00CA       {
; 0000 00CB          if(!bBlinkOn)
	SBRS R2,1
; 0000 00CC             bLed = 0;
	RCALL SUBOPT_0x9
; 0000 00CD       }
; 0000 00CE       if(bLed)
_0x29:
	SBRC R15,0
; 0000 00CF       {
; 0000 00D0          value2 |= 0x80;
	ORI  R18,LOW(128)
; 0000 00D1       }
; 0000 00D2       pState++;
	RCALL SUBOPT_0xA
; 0000 00D3    }
	SUBI R16,-1
	RJMP _0x23
_0x24:
; 0000 00D4 
; 0000 00D5    value3 = 0;
	LDI  R21,LOW(0)
; 0000 00D6    for(i = 0; i < 2; i++)
	LDI  R16,LOW(0)
_0x2D:
	CPI  R16,2
	BRSH _0x2E
; 0000 00D7    {
; 0000 00D8       value3 >>= 1;
	MOV  R30,R21
	RCALL SUBOPT_0xB
	MOV  R21,R30
; 0000 00D9       state = (*pState) & (~BLINKING);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
; 0000 00DA       bLed = 0;
; 0000 00DB       if(state == LED_ON)
	BREQ _0x8F
; 0000 00DC       {
; 0000 00DD          bLed = 1;
; 0000 00DE       }
; 0000 00DF       else if(state == LED_DIM)
	CPI  R17,2
	BRNE _0x31
; 0000 00E0       {
; 0000 00E1          if((framecount & FRAME_MASK) == FRAME_MASK)
	RCALL SUBOPT_0x8
	BRNE _0x32
; 0000 00E2             bLed = 1;
_0x8F:
	SET
	BLD  R15,0
; 0000 00E3       }
_0x32:
; 0000 00E4       if((*pState) & BLINKING)
_0x31:
	RCALL SUBOPT_0x6
	ANDI R30,LOW(0x80)
	BREQ _0x33
; 0000 00E5       {
; 0000 00E6          if(!bBlinkOn)
	SBRS R2,1
; 0000 00E7             bLed = 0;
	RCALL SUBOPT_0x9
; 0000 00E8       }
; 0000 00E9       if(bLed)
_0x33:
	SBRC R15,0
; 0000 00EA       {
; 0000 00EB          value3 |= 0x02;
	ORI  R21,LOW(2)
; 0000 00EC       }
; 0000 00ED       pState++;
	RCALL SUBOPT_0xA
; 0000 00EE    }
	SUBI R16,-1
	RJMP _0x2D
_0x2E:
; 0000 00EF 
; 0000 00F0    PORTC &= (~0x0F);
	IN   R30,0x15
	ANDI R30,LOW(0xF0)
	OUT  0x15,R30
; 0000 00F1    PORTD &= (~0xF0);
	IN   R30,0x12
	ANDI R30,LOW(0xF)
	OUT  0x12,R30
; 0000 00F2    PORTB &= (~0x03);
	IN   R30,0x18
	ANDI R30,LOW(0xFC)
	OUT  0x18,R30
; 0000 00F3    P_STROBE = 1;
	SBI  0x18,2
; 0000 00F4    P_STROBE = 0;
	CBI  0x18,2
; 0000 00F5    PORTC |= (value1);
	IN   R30,0x15
	OR   R30,R19
	OUT  0x15,R30
; 0000 00F6    PORTD |= (value2);
	IN   R30,0x12
	OR   R30,R18
	OUT  0x12,R30
; 0000 00F7    PORTB |= (value3);
	IN   R30,0x18
	OR   R30,R21
	OUT  0x18,R30
; 0000 00F8 
; 0000 00F9 }
	RCALL __LOADLOCR6
	ADIW R28,8
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;// initialization of Timer0
;void initTimer0(void)
; 0000 00FE {
_initTimer0:
; 0000 00FF // Timer/Counter 0 initialization
; 0000 0100 // Clock source: System Clock
; 0000 0101 // Clock value: 1000,000 kHz
; 0000 0102 TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 0103 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0104 
; 0000 0105 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0106 TIMSK |= 0x01;
	IN   R30,0x39
	ORI  R30,1
	RJMP _0x2080007
; 0000 0107 }
;
;
;
;
;
;// Timer 2 overflow interrupt service routine
;// clock interrupt
;// occurs every 1 second
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0111 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0112    if(seconds < 59)
	LDI  R30,LOW(59)
	CP   R5,R30
	BRSH _0x3A
; 0000 0113    {
; 0000 0114       seconds++;
	INC  R5
; 0000 0115    }
; 0000 0116    else
	RJMP _0x3B
_0x3A:
; 0000 0117    {
; 0000 0118       seconds = 0;
	CLR  R5
; 0000 0119       if(minutes < 59)
	LDI  R30,LOW(59)
	CP   R4,R30
	BRSH _0x3C
; 0000 011A          minutes++;
	INC  R4
; 0000 011B       else
	RJMP _0x3D
_0x3C:
; 0000 011C       {
; 0000 011D          minutes = 0;
	CLR  R4
; 0000 011E          if(hours < 23)
	LDI  R30,LOW(23)
	CP   R7,R30
	BRSH _0x3E
; 0000 011F             hours++;
	INC  R7
; 0000 0120          else
	RJMP _0x3F
_0x3E:
; 0000 0121             hours = 0;
	CLR  R7
; 0000 0122       }
_0x3F:
_0x3D:
; 0000 0123       if((minutes % 15) == 0)
	MOV  R26,R4
	CLR  R27
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RCALL __MODW21
	SBIW R30,0
	BRNE _0x40
; 0000 0124       {                // play sound every 15 minutes
; 0000 0125          bSound = 1;
	SET
	BLD  R2,0
; 0000 0126       }
; 0000 0127    }
_0x40:
_0x3B:
; 0000 0128 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;// initialization of Timer2
;void initTimer2(void)
; 0000 012D {
_initTimer2:
; 0000 012E // Timer/Counter 2 initialization
; 0000 012F // Clock source: TOSC1 pin
; 0000 0130 // Clock value: PCK2/128
; 0000 0131 // Mode: Normal top=FFh
; 0000 0132 // OC2 output: Disconnected
; 0000 0133 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 0134 TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 0135 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0136 OCR2=0x00;
	OUT  0x23,R30
; 0000 0137 
; 0000 0138 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0139 TIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
_0x2080007:
	OUT  0x39,R30
; 0000 013A }
	RET
;
;
;
;// stop Timer2
;void stopTimer2(void)
; 0000 0140 {
_stopTimer2:
; 0000 0141 TCCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0142 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0143 }
	RET
;
;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0149 {
_ext_int0_isr:
; 0000 014A }
	RETI
;
;
;// initialization of INT0
;void initInt0(void)
; 0000 014F {
_initInt0:
; 0000 0150    // External Interrupt(s) initialization
; 0000 0151    // INT0: disabled
; 0000 0152    // INT0 Mode: Low level
; 0000 0153    GICR &= (~0x40);   //disable INT0
	IN   R30,0x3B
	ANDI R30,0xBF
	OUT  0x3B,R30
; 0000 0154    MCUCR &= 0xFC;
	IN   R30,0x35
	ANDI R30,LOW(0xFC)
	OUT  0x35,R30
; 0000 0155    GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0156 }
	RET
;
;
;// initialization of ports
;void init(void)
; 0000 015B {
_init:
; 0000 015C PORTB = 0;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 015D DDRB = 0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
; 0000 015E PORTC = 0;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 015F DDRC = 0x0F;
	LDI  R30,LOW(15)
	OUT  0x14,R30
; 0000 0160 PORTD = 0;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0161 DDRD = 0xF4;
	LDI  R30,LOW(244)
	OUT  0x11,R30
; 0000 0162 PULLUP_KEY = 1;
	SBI  0x12,3
; 0000 0163 P_SHUTDOWN_SD = 0;
	CBI  0x12,1
; 0000 0164 DP_SHUTDOWN_SD = 1;
	SBI  0x11,1
; 0000 0165 // Analog Comparator initialization
; 0000 0166 // Analog Comparator: Off
; 0000 0167 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0168 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0169 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 016A }
	RET
;
;
;#define ADC_VREF_TYPE 0x00
;
;// initialization of ADC
;void initADC(void)
; 0000 0171 {
_initADC:
; 0000 0172    // ADC initialization
; 0000 0173    // ADC Clock frequency: 125,000 kHz
; 0000 0174    // ADC Voltage Reference: AREF pin
; 0000 0175    ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(0)
	OUT  0x7,R30
; 0000 0176    ADCSRA=0x86;
	LDI  R30,LOW(134)
	OUT  0x6,R30
; 0000 0177 }
	RET
;
;
;// Read the AD conversion result
;// adc_input: ADC channel (0..7)
;// return: ADC value (0..1023)
;unsigned int read_adc(unsigned char adc_input)
; 0000 017E {
_read_adc:
; 0000 017F    ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
; 0000 0180    // Delay needed for the stabilization of the ADC input voltage
; 0000 0181    delay_us(10);
	__DELAY_USB 27
; 0000 0182    // Start the AD conversion
; 0000 0183    ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0184    // Wait for the AD conversion to complete
; 0000 0185    while ((ADCSRA & 0x10)==0);
_0x47:
	SBIS 0x6,4
	RJMP _0x47
; 0000 0186    ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0187 
; 0000 0188    return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	RJMP _0x2080001
; 0000 0189 }
;
;
;// select minute lower digit
;// return: selected minute lower digit (0...9)
;unsigned char selectMinutes1(void)
; 0000 018F {
_selectMinutes1:
; 0000 0190    unsigned char x;
; 0000 0191 
; 0000 0192    x = 9 - (read_adc(7) / (1023/10 + 1));
	RCALL SUBOPT_0xC
;	x -> R17
	LDI  R30,LOW(103)
	LDI  R31,HIGH(103)
	RCALL __DIVW21U
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	RJMP _0x2080004
; 0000 0193 
; 0000 0194    return(x);
; 0000 0195 }
;
;
;// select minute upper digit
;// return: selected minute upper digit (0...5)
;unsigned char selectMinutes10(void)
; 0000 019B {
_selectMinutes10:
; 0000 019C    unsigned char x;
; 0000 019D 
; 0000 019E    x = (read_adc(6) / (1023/6 + 1));
	ST   -Y,R17
;	x -> R17
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R26,R30
	LDI  R30,LOW(171)
	LDI  R31,HIGH(171)
	RCALL __DIVW21U
	RJMP _0x2080003
; 0000 019F 
; 0000 01A0    return(x);
; 0000 01A1 }
;
;
;// select hour
;// return: selected hour (0...11)
;unsigned char selectHour(void)
; 0000 01A7 {
_selectHour:
; 0000 01A8    unsigned char x;
; 0000 01A9 
; 0000 01AA    x = 11 - (read_adc(7) / (1023/12 + 1));
	RCALL SUBOPT_0xC
;	x -> R17
	LDI  R30,LOW(86)
	LDI  R31,HIGH(86)
	RCALL __DIVW21U
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
_0x2080004:
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
_0x2080003:
	MOV  R17,R30
; 0000 01AB 
; 0000 01AC    return(x);
_0x2080005:
	MOV  R30,R17
_0x2080006:
	LD   R17,Y+
	RET
; 0000 01AD }
;
;
;
;// initialize I2C interface
;void initI2C(void)
; 0000 01B3 {
_initI2C:
; 0000 01B4    // Two Wire Bus initialization
; 0000 01B5    // Bit Rate: 25,000 kHz
; 0000 01B6    TWBR=0x98;
	LDI  R30,LOW(152)
	OUT  0x0,R30
; 0000 01B7    // Two Wire Bus Slave Address: 0h
; 0000 01B8    // General Call Recognition: Off
; 0000 01B9    TWAR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 01BA    // Generate Acknowledge Pulse: On
; 0000 01BB    // TWI Interrupt: Off
; 0000 01BC    TWCR=0x44;
	LDI  R30,LOW(68)
	RJMP _0x2080002
; 0000 01BD    TWSR=0x00;
; 0000 01BE }
;
;
;
;// disable I2C interface
;void disableI2C(void)
; 0000 01C4 {
_disableI2C:
; 0000 01C5    TWCR=0x00;
	LDI  R30,LOW(0)
_0x2080002:
	OUT  0x36,R30
; 0000 01C6    TWSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x1,R30
; 0000 01C7 }
	RET
;
;
;#define TWINT 7
;#define TWSTA 5
;#define TWSTO 4
;#define TWEN  2
;
;// I2C start condition
;void i2cStart(void)
; 0000 01D1 {
_i2cStart:
; 0000 01D2    TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN);
	LDI  R30,LOW(164)
	OUT  0x36,R30
; 0000 01D3 
; 0000 01D4    while (!(TWCR & (1<<TWINT)));
_0x4A:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x4A
; 0000 01D5 
; 0000 01D6 }
	RET
;
;
;// I2c stop condition
;void i2cStop(void)
; 0000 01DB {
_i2cStop:
; 0000 01DC    TWCR = (1<<TWINT) | (1<<TWSTO) | (1<<TWEN);
	LDI  R30,LOW(148)
	OUT  0x36,R30
; 0000 01DD }
	RET
;
;
;// I2C send a byte
;// c: byte to send
;void i2cSend(unsigned char c)
; 0000 01E3 {
_i2cSend:
; 0000 01E4    TWDR = c;
;	c -> Y+0
	LD   R30,Y
	OUT  0x3,R30
; 0000 01E5    TWCR = (1<<TWINT) | (1<<TWEN);
	LDI  R30,LOW(132)
	OUT  0x36,R30
; 0000 01E6 
; 0000 01E7    while (!(TWCR & (1<<TWINT)));
_0x4D:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x4D
; 0000 01E8 }
_0x2080001:
	ADIW R28,1
	RET
;
;
;// show decimal value on display
;// d: value to be displayed (0...99)
;// state: display as dimmed or ON (LED_DIM or LED_ON)
;void showDecimal(unsigned char d, unsigned char state)
; 0000 01EF {
_showDecimal:
; 0000 01F0    unsigned char i, j, k, value, col, divisor, pattern;
; 0000 01F1 
; 0000 01F2    col = 2;
	SBIW R28,1
	RCALL __SAVELOCR6
;	d -> Y+8
;	state -> Y+7
;	i -> R17
;	j -> R16
;	k -> R19
;	value -> R18
;	col -> R21
;	divisor -> R20
;	pattern -> Y+6
	LDI  R21,LOW(2)
; 0000 01F3    divisor = 10;
	LDI  R20,LOW(10)
; 0000 01F4    for(k = 0; k < 2; k++)
	LDI  R19,LOW(0)
_0x51:
	CPI  R19,2
	BRSH _0x52
; 0000 01F5    {
; 0000 01F6       value = d / divisor;
	RCALL SUBOPT_0xD
	RCALL __DIVW21
	MOV  R18,R30
; 0000 01F7       for(j = 0; j < 3; j++)
	LDI  R16,LOW(0)
_0x54:
	CPI  R16,3
	BRSH _0x55
; 0000 01F8       {      // show decimal using stored font
; 0000 01F9          pattern = decimals[value*3 + j];
	LDI  R30,LOW(3)
	MUL  R30,R18
	MOVW R30,R0
	MOVW R26,R30
	MOV  R30,R16
	RCALL SUBOPT_0xE
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_decimals*2)
	SBCI R31,HIGH(-_decimals*2)
	LPM  R0,Z
	STD  Y+6,R0
; 0000 01FA          for(i = 0; i < 5; i++)
	LDI  R17,LOW(0)
_0x57:
	CPI  R17,5
	BRSH _0x58
; 0000 01FB          {
; 0000 01FC             if( pattern & (0x01 << i) )
	MOV  R30,R17
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDD  R26,Y+6
	RCALL SUBOPT_0xF
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x59
; 0000 01FD                ledState[col*HEIGHT + 3 + i] = state;
	RCALL SUBOPT_0x10
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x1
	LDD  R26,Y+7
	RJMP _0x90
; 0000 01FE             else
_0x59:
; 0000 01FF                ledState[col*HEIGHT + 3 + i] = LED_OFF;
	RCALL SUBOPT_0x10
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x1
	LDI  R26,LOW(0)
_0x90:
	STD  Z+0,R26
; 0000 0200          }
	SUBI R17,-1
	RJMP _0x57
_0x58:
; 0000 0201          col++;
	SUBI R21,-1
; 0000 0202       }
	SUBI R16,-1
	RJMP _0x54
_0x55:
; 0000 0203       col++;
	SUBI R21,-1
; 0000 0204       d = d % divisor;
	RCALL SUBOPT_0xD
	RCALL __MODW21
	STD  Y+8,R30
; 0000 0205       divisor = divisor / 10;
	MOV  R26,R20
	RCALL SUBOPT_0xF
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	MOV  R20,R30
; 0000 0206    }
	SUBI R19,-1
	RJMP _0x51
_0x52:
; 0000 0207 
; 0000 0208 }
	RCALL __LOADLOCR6
	ADIW R28,9
	RET
;
;
;// show clock on display:
;// 1 LED for each hour, current hour LED is ON, other 11 LEDs are dimmed
;// minutes or seconds are displayed as 2 digits decimal
;// cShowMinutes: 1=show minutes, 0=show seconds
;// cDecimalState: display decimals as dimmed or ON (LED_DIM or LED_ON)
;void showClock(unsigned char cShowMinutes, unsigned char cDecimalState)
; 0000 0211 {
_showClock:
; 0000 0212    unsigned char i, cValue, cHour, state;
; 0000 0213 
; 0000 0214    if(cShowMinutes)
	RCALL __SAVELOCR4
;	cShowMinutes -> Y+5
;	cDecimalState -> Y+4
;	i -> R17
;	cValue -> R16
;	cHour -> R19
;	state -> R18
	LDD  R30,Y+5
	CPI  R30,0
	BREQ _0x5B
; 0000 0215       cValue = minutes;
	MOV  R16,R4
; 0000 0216    else
	RJMP _0x5C
_0x5B:
; 0000 0217       cValue = seconds;
	MOV  R16,R5
; 0000 0218 
; 0000 0219    cHour = hours;
_0x5C:
	MOV  R19,R7
; 0000 021A    if(cHour >= 12)
	CPI  R19,12
	BRLO _0x5D
; 0000 021B       cHour -= 12;
	RCALL SUBOPT_0x5
	SBIW R30,12
	MOV  R19,R30
; 0000 021C 
; 0000 021D    for(i = 0; i < 12; i++)
_0x5D:
	LDI  R17,LOW(0)
_0x5F:
	CPI  R17,12
	BRSH _0x60
; 0000 021E    {
; 0000 021F       if(i == cHour)
	CP   R19,R17
	BRNE _0x61
; 0000 0220          state = LED_ON;
	LDI  R18,LOW(1)
; 0000 0221       else
	RJMP _0x62
_0x61:
; 0000 0222          state = LED_DIM;
	LDI  R18,LOW(2)
; 0000 0223       ledState[ledHours[i]] = state;
_0x62:
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_ledHours*2)
	SBCI R31,HIGH(-_ledHours*2)
	LPM  R30,Z
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1
	ST   Z,R18
; 0000 0224    }
	SUBI R17,-1
	RJMP _0x5F
_0x60:
; 0000 0225    showDecimal(cValue, cDecimalState);
	ST   -Y,R16
	LDD  R30,Y+5
	ST   -Y,R30
	RCALL _showDecimal
; 0000 0226 
; 0000 0227 }
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;
;
;// main routine
;void main(void)
; 0000 022C {
_main:
; 0000 022D    unsigned char d, d10, index=0, i, bongCounter=0;
; 0000 022E    unsigned int iCountSCL;
; 0000 022F    bit bShowMinutes = 1;
; 0000 0230    bit bCheckSoundEnd = 0;
; 0000 0231 
; 0000 0232    init();
	SBIW R28,2
;	d -> R17
;	d10 -> R16
;	index -> R19
;	i -> R18
;	bongCounter -> R21
;	iCountSCL -> Y+0
;	bShowMinutes -> R15.0
;	bCheckSoundEnd -> R15.1
	LDI  R30,LOW(1)
	MOV  R15,R30
	LDI  R19,0
	LDI  R21,0
	RCALL _init
; 0000 0233    initTimer0();
	RCALL _initTimer0
; 0000 0234    initTimer2();
	RCALL _initTimer2
; 0000 0235    initADC();
	RCALL _initADC
; 0000 0236    initInt0();
	RCALL _initInt0
; 0000 0237 
; 0000 0238    clearScreen();
	RCALL _clearScreen
; 0000 0239 
; 0000 023A 
; 0000 023B    #asm("sei")      // Global enable interrupts
	sei
; 0000 023C 
; 0000 023D 
; 0000 023E    while(1)
_0x63:
; 0000 023F    {
; 0000 0240       if(KEY_PRESSED)
	SBIC 0x10,3
	RJMP _0x66
; 0000 0241       {
; 0000 0242          delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x2
; 0000 0243          i = 50;
	LDI  R18,LOW(50)
; 0000 0244          while( keyPressed() && (i != 0) )   // check for short or long keypress
_0x67:
	RCALL _keyPressed
	CPI  R30,0
	BREQ _0x6A
	CPI  R18,0
	BRNE _0x6B
_0x6A:
	RJMP _0x69
_0x6B:
; 0000 0245          {
; 0000 0246             i--;
	SUBI R18,1
; 0000 0247          }
	RJMP _0x67
_0x69:
; 0000 0248          if(i == 0)
	CPI  R18,0
	BRNE _0x6C
; 0000 0249          {  // long keypress => set time
; 0000 024A             stopTimer2();
	RCALL _stopTimer2
; 0000 024B             showClock(1, LED_OFF);
	RCALL SUBOPT_0x11
; 0000 024C             waitUntilKeyreleased();
	RCALL _waitUntilKeyreleased
; 0000 024D 
; 0000 024E             do
_0x6E:
; 0000 024F             {
; 0000 0250                d = selectHour();        // select hour (0-11)
	RCALL _selectHour
	MOV  R17,R30
; 0000 0251                hours = d;
	MOV  R7,R17
; 0000 0252                showClock(1, LED_OFF);
	RCALL SUBOPT_0x11
; 0000 0253             }
; 0000 0254             while(!keyPressed());
	RCALL _keyPressed
	CPI  R30,0
	BREQ _0x6E
; 0000 0255             waitUntilKeyreleased();
	RCALL _waitUntilKeyreleased
; 0000 0256 
; 0000 0257             do
_0x71:
; 0000 0258             {
; 0000 0259                d10 = selectMinutes10(); // select minutes upper digit (0-5)
	RCALL _selectMinutes10
	MOV  R16,R30
; 0000 025A                d = selectMinutes1();    // select minutes lower digit (0-9)
	RCALL _selectMinutes1
	MOV  R17,R30
; 0000 025B                minutes = d10*10 + d;
	LDI  R26,LOW(10)
	MULS R16,R26
	MOVW R30,R0
	ADD  R30,R17
	MOV  R4,R30
; 0000 025C                showClock(1, LED_ON);
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _showClock
; 0000 025D             }
; 0000 025E             while(!keyPressed());
	RCALL _keyPressed
	CPI  R30,0
	BREQ _0x71
; 0000 025F             waitUntilKeyreleased();
	RCALL _waitUntilKeyreleased
; 0000 0260 
; 0000 0261             seconds = 0;
	CLR  R5
; 0000 0262             showClock(0, LED_DIM);
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x12
; 0000 0263             bShowMinutes = 0;           // show seconds in display after setting clock
	RCALL SUBOPT_0x9
; 0000 0264             waitUntilKeypressed();
	RCALL _waitUntilKeypressed
; 0000 0265             waitUntilKeyreleased();
	RCALL _waitUntilKeyreleased
; 0000 0266             initTimer2();
	RCALL _initTimer2
; 0000 0267          }
; 0000 0268          else
	RJMP _0x73
_0x6C:
; 0000 0269          {  // short keypress => toggle between display of minutes and seconds
; 0000 026A             bShowMinutes = ~bShowMinutes;
	LDI  R30,LOW(1)
	EOR  R15,R30
; 0000 026B          }
_0x73:
; 0000 026C       }
; 0000 026D 
; 0000 026E       showClock(bShowMinutes, LED_DIM); // show current time on display
_0x66:
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
	RCALL SUBOPT_0x12
; 0000 026F 
; 0000 0270       if(bSound)                 // check if sound has to be played
	SBRS R2,0
	RJMP _0x74
; 0000 0271       {
; 0000 0272          index = minutes / 15;   // sound 1-4: 1/4, 1/2, 3/4, 4/4 hour
	MOV  R26,R4
	RCALL SUBOPT_0xF
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RCALL __DIVW21
	MOV  R19,R30
; 0000 0273          if(index == 0)
	CPI  R19,0
	BRNE _0x75
; 0000 0274          {
; 0000 0275             index = 4;
	LDI  R19,LOW(4)
; 0000 0276          }
; 0000 0277          bSound = 0;
_0x75:
	CLT
	BLD  R2,0
; 0000 0278          if(index == 4)          // each hour, "bong" current hours
	CPI  R19,4
	BRNE _0x76
; 0000 0279          {
; 0000 027A             bongCounter = hours;
	MOV  R21,R7
; 0000 027B             if(bongCounter > 12)
	CPI  R21,13
	BRLO _0x77
; 0000 027C                bongCounter -= 12;
	MOV  R30,R21
	RCALL SUBOPT_0xE
	SBIW R30,12
	MOV  R21,R30
; 0000 027D             if(bongCounter == 0)
_0x77:
	CPI  R21,0
	BRNE _0x78
; 0000 027E                bongCounter = 12;
	LDI  R21,LOW(12)
; 0000 027F          }
_0x78:
; 0000 0280       }
_0x76:
; 0000 0281 
; 0000 0282       if(index)           // check if SD card player has to be started
_0x74:
	CPI  R19,0
	BREQ _0x79
; 0000 0283       {
; 0000 0284          P_SCL = 1;       // enable pullups for I2C
	SBI  0x15,5
; 0000 0285          P_SDA = 1;
	SBI  0x15,4
; 0000 0286 
; 0000 0287          SD_PLAYER_ON;
	SBI  0x12,1
; 0000 0288 
; 0000 0289          delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x2
; 0000 028A          initI2C();
	RCALL _initI2C
; 0000 028B          i2cStart();
	RCALL _i2cStart
; 0000 028C          i2cSend(0xAA);   // I2C address
	LDI  R30,LOW(170)
	ST   -Y,R30
	RCALL _i2cSend
; 0000 028D          i2cSend(index);  // I2C data
	ST   -Y,R19
	RCALL _i2cSend
; 0000 028E          i2cStop();
	RCALL _i2cStop
; 0000 028F 
; 0000 0290          disableI2C();
	RCALL _disableI2C
; 0000 0291 
; 0000 0292          delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x2
; 0000 0293          index = 0;
	LDI  R19,LOW(0)
; 0000 0294          iCountSCL = 0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 0295          bCheckSoundEnd = 1;
	SET
	BLD  R15,1
; 0000 0296       }
; 0000 0297 
; 0000 0298       if(bCheckSoundEnd)
_0x79:
	SBRS R15,1
	RJMP _0x80
; 0000 0299       {                   // check for sound end, if SCL is permanent HIGH
; 0000 029A          if(PIN_SCL)
	SBIS 0x13,5
	RJMP _0x81
; 0000 029B          {
; 0000 029C             iCountSCL++;
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
; 0000 029D          }
; 0000 029E          else
	RJMP _0x82
_0x81:
; 0000 029F          {
; 0000 02A0             iCountSCL = 0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 02A1          }
_0x82:
; 0000 02A2 
; 0000 02A3          if(iCountSCL >= 1000)
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRLO _0x83
; 0000 02A4          {
; 0000 02A5             bCheckSoundEnd = 0;
	CLT
	BLD  R15,1
; 0000 02A6 
; 0000 02A7             if(bongCounter)
	CPI  R21,0
	BREQ _0x84
; 0000 02A8             {
; 0000 02A9                index = 5;       // sound 5: "bong"
	LDI  R19,LOW(5)
; 0000 02AA                bongCounter--;
	SUBI R21,1
; 0000 02AB             }
; 0000 02AC             else
	RJMP _0x85
_0x84:
; 0000 02AD             {
; 0000 02AE                P_SCL = 0;       // disable pullups for I2C
	CBI  0x15,5
; 0000 02AF                P_SDA = 0;
	CBI  0x15,4
; 0000 02B0 
; 0000 02B1                SD_PLAYER_OFF;   // switch OFF SD card player
	CBI  0x12,1
; 0000 02B2             }
_0x85:
; 0000 02B3          }
; 0000 02B4       }
_0x83:
; 0000 02B5 
; 0000 02B6    }
_0x80:
	RJMP _0x63
; 0000 02B7 }
_0x8C:
	RJMP _0x8C
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_ledState:
	.BYTE 0x78
_count_S0000004000:
	.BYTE 0x1
_framecount_S0000004000:
	.BYTE 0x1
_blinkcounter_S0000004000:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	SUBI R30,LOW(-_ledState)
	SBCI R31,HIGH(-_ledState)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDS  R30,_framecount_S0000004000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	ANDI R30,0x7F
	MOV  R17,R30
	CLT
	BLD  R15,0
	CPI  R17,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0x3)
	CPI  R30,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	CLT
	BLD  R15,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	LDI  R31,0
	ASR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	ST   -Y,R17
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDD  R26,Y+8
	CLR  R27
	MOV  R30,R20
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(10)
	MUL  R30,R21
	MOVW R30,R0
	ADIW R30,3
	MOVW R26,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _showClock

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _showClock


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
